#ifndef LIBCLI_H
#define LIBCLI_H

#include <stdio.h>
#include <unistd.h>

typedef enum {CLI_OPTION_FLAG, CLI_OPTION_STR,
              CLI_OPTION_UINT16, CLI_OPTION_UINT32,
              CLI_OPTION_UINT16X, CLI_OPTION_UINT32X} cli_option_type_t;

#define CLI_OPTIONFL_HIDDEN      0x0001
#define CLI_OPTIONFL_REQUIRED    0x0002
#define CLI_OPTIONFL_ACCEPTED    0x8000

typedef struct cli_option_item_s {
  char *name;
  char *help;
  cli_option_type_t type;
  void *data;
  uint16_t datasize;
  uint16_t flags;
} cli_option_item_t;


/* options new interface */
cli_option_item_t** cli_create_option_array2(size_t max);
void cli_free_option_array2(cli_option_item_t** array);
int cli_add_options2(cli_option_item_t **to, const cli_option_item_t *from);
int cli_handle_opt2(cli_option_item_t **opts, cli_option_item_t **args, int argc, char **argv);
int cli_print_options_help2(const cli_option_item_t **o);
int cli_print_args_help2(const cli_option_item_t **o);
int cli_is_opt_accepted2(const cli_option_item_t **opt, const cli_option_item_t **arg, void *pdata);
int cli_is_opt_accepted(cli_option_item_t *opt, cli_option_item_t *arg, void *pdata);

/* options */
/*
cli_option_item_t* cli_create_option_array(size_t max);
void cli_free_option_array(cli_option_item_t* o);
int cli_add_options(cli_option_item_t *to, const cli_option_item_t *from);
uint16_t cli_opt_size(cli_option_item_t *o);
int cli_handle_opt(cli_option_item_t *opts, cli_option_item_t *args, int argc, char **argv);
int cli_print_options_help(cli_option_item_t *o);
int cli_print_args_help(cli_option_item_t *o);
*/

int cli_question_yesno(const char *q, int defanswer);

/* convertions */
void cli_mac2s(uint8_t * mac, char *s);
int cli_s2mac(uint8_t * mac, char *s);
int cli_s2n2(char *s, uint16_t *n);
int cli_s2nl2(char *s, uint32_t *n);
int cli_s2n10(char *s, uint16_t *n);
int cli_s2nl10(char *s, uint32_t *n);
int cli_s2n16(char *s, uint16_t *n);
int cli_s2nl16(char *s, uint32_t *n);
void cli_changecase(char *s, char up);
int cli_hexdump(FILE *f, void *buf, size_t size, uint32_t addr);
int cli_ip2s(uint8_t *d, char *s);
int cli_s2ip(uint32_t *a, char *s);
int cli_s2mask(uint32_t *m, char *s);


#endif // CMD_H

